import os
import json
import random
import sys
import time
import uuid

import requests

sys.path.append(os.getcwd())
from common.video_item import VideoItem
from common import tunnel_proxies
from common.pipeline import PiaoQuanPipelineTest
from common.mq import MQ


def get_tencent_video_url(video_id):
    url = "https://h5vv.video.qq.com/getinfo?vid={}&platform=101001&charge=0&otype=json&defn=shd".format(
        video_id
    )
    headers = {
        "Host": "h5vv.video.qq.com",
        "xweb_xhr": "1",
        "User-Agent": "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/98.0.4758.102 Safari/537.36 MicroMessenger/6.8.0(0x16080000) NetType/WIFI MiniProgramEnv/Mac MacWechat/WMPF XWEB/30817",
        "Content-Type": "application/x-www-form-urlencoded",
        "Accept": "*/*",
        "Sec-Fetch-Site": "cross-site",
        "Sec-Fetch-Mode": "cors",
        "Sec-Fetch-Dest": "empty",
        "Referer": "https://servicewechat.com/wx5fcd817f3f80aece/3/page-frame.html",
        "Accept-Language": "en",
    }
    response = requests.get(url, headers=headers)
    result = json.loads(response.text.replace("QZOutputJson=", "")[:-1])
    vl = result["vl"]["vi"][0]
    key = vl["fvkey"]
    name = vl["fn"]
    folder = vl["ul"]["ui"][0]["url"]
    video_url = folder + name + "?vkey=" + key
    time.sleep(random.randint(1, 5))
    return video_url


class TuiXiuDaBenYingRecommend(object):
    def __init__(self, platform, mode, rule_dict, user_list, env):
        self.platform = platform
        self.mode = mode
        self.rule_dict = rule_dict
        self.user_list = user_list
        self.env = env
        self.download_cnt = 0
        self.mq = MQ(topic_name="topic_crawler_etl_" + self.env)
        self.limit_flag = False

    def get_video_list(self):
        """
        推荐流并没有页数，每次请求数据不同，设置每天的抓取视频数量为100-200条
        """
        base_url = "https://txdby.leyoukge.com/api/getVideoListByPagination"
        headers = {
            'Host': 'txdby.leyoukge.com',
            'xweb_xhr': '1',
            'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/107.0.0.0 Safari/537.36 MicroMessenger/6.8.0(0x16080000) NetType/WIFI MiniProgramEnv/Mac MacWechat/WMPF MacWechat/3.8.5(0x13080510)XWEB/1100',
            'Content-Type': 'application/x-www-form-urlencoded',
            'Accept': '*/*',
            'Referer': 'https://servicewechat.com/wx6665a673af83c3e8/3/page-frame.html',
            'Accept-Language': 'en-US,en;q=0.9'
        }
        for i in range(1, 9):
            time.sleep(random.randint(1, 10))
            try:
                if self.limit_flag:
                    message = "本轮已经抓取到足够的数据，自动退出\t{}".format(self.download_cnt)
                    print(message)
                    return
                else:
                    params = {
                        "i": 1,
                        "v": "1.0.0",
                        "class_id": 6,
                        "page": i
                    }
                    response = requests.get(
                        url=base_url,
                        headers=headers,
                        params=params,
                        proxies=tunnel_proxies(),
                    )
                    video_list = response.json()['extra']
                    if video_list:
                        for index, video_obj in enumerate(video_list, 1):
                            try:
                                print("扫描到一条视频")
                                self.process_video_obj(video_obj)
                            except Exception as e:
                                print("抓取第{}条的时候出现问题， 报错信息是{}".format(index, e))
                    else:
                        print("已经抓完了，自动退出")
                        return
            except Exception as e:
                print("抓取推荐页的时候出现错误， 报错信息是{}".format(e))

    def process_video_obj(self, video_obj):
        trace_id = self.platform + str(uuid.uuid1())
        our_user = random.choice(self.user_list)
        item = VideoItem()
        item.add_video_info("user_id", our_user["uid"])
        item.add_video_info("user_name", our_user["nick_name"])
        item.add_video_info("video_id", video_obj["id"])
        item.add_video_info("video_title", video_obj["title"])
        vid = video_obj['vid']
        video_url = get_tencent_video_url(video_id=vid)
        item.add_video_info("video_url", video_url)
        item.add_video_info("cover_url", video_obj['cover_url'])
        item.add_video_info("play_cnt", video_obj['play'])
        item.add_video_info("share_cnt", video_obj['forward'])
        item.add_video_info("out_video_id", video_obj["id"])
        item.add_video_info("platform", self.platform)
        item.add_video_info("strategy", self.mode)
        item.add_video_info("session", "{}-{}".format(self.platform, int(time.time())))
        mq_obj = item.produce_item()
        pipeline = PiaoQuanPipelineTest(
            platform=self.platform,
            mode=self.mode,
            rule_dict=self.rule_dict,
            env=self.env,
            item=mq_obj,
            trace_id=trace_id,
        )
        if pipeline.process_item():
            self.download_cnt += 1
            # self.mq.send_msg(mq_obj)
            print(json.dumps(mq_obj, ensure_ascii=False, indent=4))
            print("成功发送至 ETL")
            if self.download_cnt >= int(
                    self.rule_dict.get("videos_cnt", {}).get("min", 200)
            ):
                self.limit_flag = True


if __name__ == '__main__':
    S = TuiXiuDaBenYingRecommend(
        platform="tuixiudabenying",
        mode="recommend",
        env="dev",
        rule_dict={},
        user_list=[{'nick_name': "Ivring", 'uid': "1997"}, {'nick_name': "paul", 'uid': "1998"}]
    )
    S.get_video_list()